//================================================================================
// ANNAWindow. (C) 2012 "Dei" & Nobody
//================================================================================
class ANNAWindow extends MenuUIScreenWindow;

var MenuUIMenuButtonWindow winButtons[4];
var string ButtonNames[4];
var int buttonWidth;
var S_MenuButton buttonDefaults[4];

struct S_MenuButton
{
	var int Y;
	var int X;
	var EMenuActions Action;
	var Class Invoke;
	var string Key;
};


event InitWindow()
{
	Super.InitWindow();
	if ( UnknownFunction130(UnknownFunction119(Player.GameReplicationInfo,None),UnknownFunction129(Player.GameReplicationInfo.bTeamGame)) )
	{
		ButtonNames[0] = "Play";
		ButtonNames[1] = "";
		ButtonNames[2] = "";
	}
	IsExiting = True;
	CreateMenuButtons();
	if ( UnknownFunction130(UnknownFunction119(Player.PlayerReplicationInfo,None),Player.PlayerReplicationInfo.bIsSpectator) )
	{
		isspec = True;
	} else {
		isspec = False;
	}
}

event FocusLeftDescendant (Window leaveWindow)
{
	Super.FocusLeftDescendant(leaveWindow);
	if ( bShowAugWarning )
	{
		bShowAugWarning = False;
		Root.MessageBox(NewPlayerTitle,NewPlayerContentAug,1,False,self);
	}
}

function SetMOTDText (string MOTDText[8])
{
	local int i;

	i = 0;
	if ( UnknownFunction150(i,8) )
	{
		CreateLabel(20,UnknownFunction146(20,UnknownFunction144(i,15)),MOTDText[i]);
		UnknownFunction165(i);
		goto JL0007;
	}
	if ( miniMTLPlayer(Player).AmINewPlayer() )
	{
		Root.MessageBox(NewPlayerTitle,NewPlayerContent,0,False,self);
	}
}

event bool BoxOptionSelected (Window box, int buttonNumber)
{
	local MMMenuScreenAugSetup mmaugsetup;

	Root.PopWindow();
	if ( UnknownFunction130(UnknownFunction129(bAugsConfigured),UnknownFunction154(buttonNumber,0)) )
	{
		mmaugsetup = MMMenuScreenAugSetup(Root.InvokeMenuScreen(Class'MMMenuScreenAugSetup'));
		mmaugsetup.ResetToDefaults();
		bShowAugWarning = True;
		bAugsConfigured = True;
	}
	return True;
}

final function MenuUISmallLabelWindow CreateLabel (int X, int Y, string S)
{
	local MenuUISmallLabelWindow W;

	W = MenuUISmallLabelWindow(winClient.UnknownFunction1410(Class'MenuUISmallLabelWindow'));
	W.UnknownFunction1432(X,Y);
	W.UnknownFunction1550(S);
	W.UnknownFunction1555(False);
	return W;
}

function CreateMenuButtons ()
{
	local int buttonIndex;

	buttonIndex = 0;
	if ( UnknownFunction150(buttonIndex,4) )
	{
		if ( UnknownFunction123(ButtonNames[buttonIndex],"") )
		{
			winButtons[buttonIndex] = MenuUIMenuButtonWindow(winClient.UnknownFunction1410(Class'MenuUIMenuButtonWindow'));
			winButtons[buttonIndex].SetButtonText(ButtonNames[buttonIndex]);
			winButtons[buttonIndex].UnknownFunction1432(buttonDefaults[buttonIndex].X,buttonDefaults[buttonIndex].Y);
			winButtons[buttonIndex].UnknownFunction1433(buttonWidth);
		}
		UnknownFunction165(buttonIndex);
		goto JL0007;
	}
}

function bool ButtonActivated (Window buttonPressed)
{
	local bool bHandled;
	local int buttonIndex;

	bHandled = False;
	if ( Super.ButtonActivated(buttonPressed) )
	{
		return True;
	}
	buttonIndex = 0;
	if ( UnknownFunction150(buttonIndex,4) )
	{
		if ( UnknownFunction114(buttonPressed,winButtons[buttonIndex]) )
		{
			ProcessMenuAction(buttonDefaults[buttonIndex].Action,buttonDefaults[buttonIndex].Invoke,buttonDefaults[buttonIndex].Key);
			bHandled = True;
		} else {
			UnknownFunction165(buttonIndex);
			goto JL001F;
		}
	}
	return bHandled;
}

function ProcessCustomMenuButton (string Key)
{
	local miniMTLPlayer mmp;

	mmp = miniMTLPlayer(Player);
	isspec = False;
	if ( UnknownFunction119(mmp,None) )
	{
		switch (Key)
		{
			case "SPECTATE":
			mmp.Spectate(1);
			isspec = True;
			break;
			case "JOIN_UNATCO":
			mmp.NewChangeTeam(0);
			break;
			case "JOIN_NSF":
			mmp.NewChangeTeam(1);
			break;
			case "JOIN_AUTO":
			mmp.NewChangeTeam(2);
			break;
			default:
		}
	}
	CancelScreen();
}

function ProcessAction (string S)
{
	local miniMTLPlayer mmp;

	mmp = miniMTLPlayer(Player);
	Super.ProcessAction(S);
	switch (S)
	{
		case "AUGS":
		Root.InvokeMenuScreen(Class'MMMenuScreenAugSetup');
		break;
		case "DISC":
		Player.DisconnectPlayer();
		break;
		case "SET":
		Root.InvokeMenuScreen(Class'CBPMenuSettings');
		break;
		case "CANCEL":
		CancelScreen();
		break;
		default:
	}
}

function CancelScreen ()
{
	local MMDeusExHUD mmdxhud;

	if ( isspec )
	{
		mmdxhud = MMDeusExHUD(Root.HUD);
		if ( UnknownFunction154(mmdxhud.HUD_mode,2) )
		{
			mmdxhud.HUD_mode = 0;
			mmdxhud.UpdateSettings(Player);
		}
	}
	UnknownFunction1473(Sound'Menu_Cancel',0.25);
	Root.PopWindow();
}

defaultproperties
{
    ButtonNames(0)="Join UNATCO"

    ButtonNames(1)="Join NSF"

    ButtonNames(2)="Auto-assign"

    ButtonNames(3)="Spectate"

    buttonWidth=200

    buttonDefaults(0)=(Y=160,X=10,Action=7,Invoke=None,Key="JOIN_UNATCO"),

    buttonDefaults(1)=(Y=200,X=10,Action=7,Invoke=None,Key="JOIN_NSF"),

    buttonDefaults(2)=(Y=160,X=230,Action=7,Invoke=None,Key="JOIN_AUTO"),

    buttonDefaults(3)=(Y=200,X=230,Action=7,Invoke=None,Key="SPECTATE"),

    NewPlayerTitle="New player detected"

    NewPlayerContent="Server has detected, that you are playing DeusEx Multiplayer for the first time. Would you like to configure your augmentations now?"

    NewPlayerContentAug="Augmentations are very important part of the gameplay. You have to use them in order to be competitive against other players. Open settings menu and configure controlling keys for them."

    actionButtons(0)=