//=============================================================================
// ANNAAdvTeam. (C) 2012 "Dei" & Nobody
//=============================================================================
/**
  Gametype for the Advanced Team Deathmatch
*/
class ANNAAdvTeam extends ANNATeam;

/** @ignore */
function PreBeginPlay ()
{
    Super.PreBeginPlay();
    ResetNonCustomizableOptions();
}

/**
 Changes the game configuration to the typical ATDM settings.
*/
function ResetNonCustomizableOptions ()
{
    Super.ResetNonCustomizableOptions();
    if(!bCustomizable)
    {
        SkillsTotal=2000;
        SkillsAvail=2000;
        SkillsPerKill=2000;
        InitialAugs=2;
        AugsPerKill=2;
        MPSkillStartLevel=1;
        SaveConfig();
    }
}

DefaultProperties
{
    GameName="Adv. Team DM"
}
