//=============================================================================
// ANNAServerQuery. (C) 2012 "Dei" & Nobody
// Shamefully copied from Nephthys and modified to our needs.
// Original author Zora: http://zzora.altervista.org/Nephthys.html 
//=============================================================================
class ANNAServerQuery expands NptServerQuery;

function bool NptSendInfo(int NumPlayers)
{
    local int idx;
    local bool bResult;

    bResult = true;

    if(bReplaceBackslashes )
        bResult = bResult && NptSendPart("\\hostname\\" $ StrReplace(Level.Game.GameReplicationInfo.ServerName, "\\", "/"));
    else
        bResult = bResult && NptSendPart("\\hostname\\" $ Level.Game.GameReplicationInfo.ServerName);

    bResult = bResult && NptSendPart("\\hostport\\" $ Level.Game.GetServerPort());

    if(bReplaceBackslashes)
        bResult = bResult && NptSendPart("\\maptitle\\" $ StrReplace(Level.Title, "\\", "/"));
    else
        bResult = bResult && NptSendPart("\\maptitle\\" $ Level.Title);

    bResult = bResult && NptSendPart("\\mapname\\" $ GetMapFileName());

    if(Len(Level.Game.GameName) != 0 && Level.Game.GameName != "Game" )
        bResult = bResult && NptSendPart("\\gametype\\" $ Level.Game.GameName);
    else
        bResult = bResult && NptSendPart("\\gametype\\" $ GetItemName(string(Level.Game.Class)));

    bResult = bResult && NptSendPart("\\numplayers\\" $ NumPlayers);
    bResult = bResult && NptSendPart("\\maxplayers\\" $ Level.Game.MaxPlayers);
    bResult = bResult && NptSendPart("\\gamemode\\openplaying");
    bResult = bResult && NptSendPart("\\gamever\\" $ Level.EngineVersion);
    bResult = bResult && NptSendPart("\\minnetver\\" $ Level.MinNetVersion);

    for(idx = 0; idx < ArrayCount(AddServerRule) && AddServerRule[idx].Tag != ""; idx++)
    {
        if(bReplaceBackslashes)
            bResult = bResult && NptSendPart("\\" $ StrReplace(AddServerRule[idx].Tag, "\\", "/") $ "\\" $ StrReplace(AddServerRule[idx].Value, "\\", "/"));
        else
            bResult = bResult && NptSendPart("\\" $ AddServerRule[idx].Tag $ "\\" $ AddServerRule[idx].Value);
    }

    bResult = bResult && NptSendPart(Level.Game.GetInfo());
    return bResult;
}